searchData={"content_type":"text/markdown","items":[{"doc":"A project-specific command-line option parser","ref":"HelpfulOptions.html","title":"HelpfulOptions","type":"module"},{"doc":"","ref":"HelpfulOptions.html#help/1","title":"HelpfulOptions.help/1","type":"function"},{"doc":"Parses command arguments, returns an error if\nrequired arguments are not supplied and sets the logging level\n\n  iex> HelpfulOptions.run([\"--foo\", \"hi\"], switches: [foo: %{type: :string}])\n  {:ok, %{foo: \"hi\"}, []}\n\n  iex> HelpfulOptions.run([\"-f\", \"hi\"], switches: [foo: %{type: :string}], aliases: [f: :foo])\n  {:ok, %{foo: \"hi\"}, []}\n\n  iex> HelpfulOptions.run([\"--bar\", \"hi\"], switches: [foo: %{type: :string}])\n  {:error, \"Unexpected parameters supplied: [\\\"--bar\\\"]\"}\n\n  iex> HelpfulOptions.run([\"non-switch\"], remaining: 1)\n  {:ok, %{}, [\"non-switch\"]}\n\n  iex> HelpfulOptions.run([\"pizza\"])\n  {:error, \"You supplied unexpected non-switch arguments [\\\"pizza\\\"]\"}\n\n  iex> HelpfulOptions.run([\"first\", \"second\"], remaining: 2..3)\n  {:ok, %{}, [\"first\", \"second\"]}\n\n  iex> HelpfulOptions.run([\"first\"], remaining: 2)\n  {:error, \"Supply 2 non-switch arguments\"}\n\n  iex> HelpfulOptions.run([\"first\"], remaining: 2..3)\n  {:error, \"Supply 2..3 non-switch arguments\"}\n\n  iex> HelpfulOptions.help([foo: %{type: :boolean}])\n  \"Options:\\n  --foo                      Optional parameter\"\n\n  iex> HelpfulOptions.help([foo: %{type: :string}])\n  \"Options:\\n  --foo=FOO                  Optional parameter\"\n\n  iex> HelpfulOptions.help([foo: %{type: :string, required: true}])\n  \"Options:\\n  --foo=FOO                  Required\"\n\n  iex> HelpfulOptions.help([foo: %{type: :boolean, description: \"Frobnicate\"}])\n  \"Options:\\n  --foo                      Frobnicate\"\n\n  iex> HelpfulOptions.help([foo: %{type: :string, description: \"Frobnicate\"}])\n  \"Options:\\n  --foo=FOO                  Frobnicate\"\n\n  iex> HelpfulOptions.help([foo: %{type: :string, description: \"Frobnicate\", required: true}])\n  \"Options:\\n  --foo=FOO                  Frobnicate. Required\"","ref":"HelpfulOptions.html#run/2","title":"HelpfulOptions.run/2","type":"function"}]}